Magellan Linux

Contents of /trunk/mage/usr/lib/mage/smage2.functions.sh

Parent Directory Parent Directory | Revision Log Revision Log


Revision 2140 - (show annotations) (download) (as text)
Mon Jul 15 07:50:48 2013 UTC (10 years, 9 months ago) by niro
File MIME type: application/x-sh
File size: 30191 byte(s)
-remove excessive tabbing and duplicate entries from dependencies
1 #!/bin/bash
2 # smage2 releated functions
3 # $Id$
4
5 # sources the smage file and uses state from distribution file if exist
6 # may helpful for repository support later on
7 smagesource()
8 {
9 local file="$1"
10 local localstate
11 local distfilestate
12 local mytag
13
14 source ${file}
15
16 # if PCAT was not set and PCATEGORIE was found
17 # inform the user and use PCATEGORIE as PCAT
18 if [[ -z ${PCAT} ]]
19 then
20 if [[ -n ${PCATEGORIE} ]]
21 then
22 PCAT="${PCATEGORIE}"
23 unset PCATEGORIE
24 # print a warning
25 echo -e "${COLYELLOW}Warning: 'PCATEGORIE' is deprecated and gets removed in the future.${COLDEFAULT}"
26 echo -e "${COLYELLOW} Please modify this smage2 script to use the 'PCAT' variable.${COLDEFAULT}"
27 echo
28 else
29 die "Neither PCAT nor PCATEGORIE are defined!"
30 fi
31 fi
32
33 [[ -n ${STATE} ]] && localstate="${STATE}"
34 [[ -n ${DISTROTAG} ]] && mytag="${DISTROTAG}"
35
36 if [ -f ${SMAGESCRIPTSDIR}/distribution ]
37 then
38 source ${SMAGESCRIPTSDIR}/distribution
39 [[ -n ${STATE} ]] && distfilestate="${STATE}"
40 [[ -n ${DISTROTAG} ]] && mytag="${DISTROTAG}"
41 fi
42 # now switch state and export it but do not overide any local states
43 if [[ ! -z ${localstate} ]]
44 then
45 STATE="${localstate}"
46 else
47 STATE="${distfilestate}"
48 fi
49
50 if mqueryfeature "pkgdistrotag"
51 then
52 # if DISTROTAG was not defined globally
53 # or in distribution file then deactivate this feature!
54 # at this point $mytag must have the distrotag
55 if [[ -z ${mytag} ]]
56 then
57 FVERBOSE=off msetfeature "!pkgdistrotag"
58 unset DISTROTAG
59 echo -e "${COLRED}Requested 'pkgdistrotag' but no \$DISTROTAG found!${COLDEFAULT}"
60 echo -e "${COLRED}Disabled the feature for pkgbuild sanity!${COLDEFAULT}"
61 else
62 # now switch state and export it but do not overide any local states
63 export DISTROTAG="${mytag}"
64 fi
65 else
66 unset DISTROTAG
67 fi
68 }
69
70 print_distrotag()
71 {
72 if FVERBOSE=off mqueryfeature "pkgdistrotag"
73 then
74 if [[ ! -z ${DISTROTAG} ]]
75 then
76 # add a point as prefix
77 echo ".${DISTROTAG}"
78 fi
79 fi
80 }
81
82 showversion()
83 {
84 echo -en "Magellan Source Install v${SMAGEVERSION} "
85 echo -e "-- Niels Rogalla (niro@magellan-linux.de)"
86 }
87
88 die()
89 {
90 xtitleclean
91 echo -e ${COLRED}"Exited ${BASH_SOURCE} at line no ${BASH_LINENO}."${COLDEFAULT}
92 echo "SMAGE failed: $@"
93 exit 1
94 }
95
96 die_pipestatus()
97 {
98 # the status change if we do any parameter declarations!!
99 # dont do this anymore, keep this in mind!
100 #
101 # local pos="$1"
102 # local comment="$2"
103 #
104 # [ ${PIPESTATUS[${pos}]} -ne 0 ] && die "${comment}"
105 #
106 [ ${PIPESTATUS[$1]} -ne 0 ] && die "$2"
107 }
108
109 xtitle()
110 {
111 if [[ ${TERM} = xterm ]]
112 then
113 echo -ne "\033]0;[sMage: $@]\007"
114 fi
115 return 0
116 }
117
118 xtitleclean()
119 {
120 if [[ ${TERM} = xterm ]]
121 then
122 echo -ne "\033]0;\007"
123 fi
124 return 0
125 }
126
127 syncsmage2()
128 {
129 xtitle "Updating smage2-script tree ..."
130 local i
131 for i in ${SMAGE2RSYNC}
132 do
133 rsync ${RSYNC_FETCH_OPTIONS} ${i} ${SMAGESCRIPTSDIR}
134 if [[ $? = 0 ]]
135 then
136 break
137 else
138 continue
139 fi
140 done
141
142 # clean up backup files (foo~)
143 find ${SMAGESCRIPTSDIR} -name *~ -exec rm '{}' ';'
144
145 xtitleclean
146 }
147
148 # $1 filename
149 get_db_md5_sum()
150 {
151 local DB_FILE
152 local MD5_FILE
153 local i
154
155 DB_ENTRY="$(basename $1)"
156 MD5_FILE="${MD5DIR}/$(basename ${SMAGENAME} ${SMAGESUFFIX})"
157
158 i="$(cat ${MD5_FILE}| grep ${DB_ENTRY} | cut -d' ' -f1)"
159
160 echo "${i}"
161 }
162
163 download_sources()
164 {
165 [ -z "${SRC_URI}" ] && echo -e "\nNothing declared to download.\n" && return 0
166
167 local count=${#SRC_URI[*]}
168 local uri
169 local subdir
170 local outputdir
171 local db_md5_file="${MD5DIR}/$(basename ${SMAGENAME} .${SMAGESUFFIX}).md5"
172 local fetching
173 local i
174
175 # check if FETCHING is needed
176 if mchecksum --rundir "${SOURCEDIR}/${PNAME}" --file "${db_md5_file}" --method md5
177 then
178 # md5's ok, no fetching needed
179 fetching=false
180 else
181 fetching=true
182 fi
183
184 if [[ ${fetching} = true ]]
185 then
186 for ((i=0; i < count; i++))
187 do
188 # url to file
189 uri="${SRC_URI[${i}]%%' '*}"
190
191 # subdir in sources dir; the my_SRCI_URI file goes to there
192 subdir="${SRC_URI[${i}]##*' '}"
193
194 # if $subdir is not equal with $uri then an other dir is used
195 if [[ ${uri} != ${subdir} ]]
196 then
197 outputdir="${SOURCEDIR}/${PNAME}/${subdir}"
198 else
199 outputdir="${SOURCEDIR}/${PNAME}"
200 fi
201
202 echo -e "${COLBLUE}==>${COLGREEN} fetching ${uri}${COLDEFAULT}"
203 # always use verbose mode for source downloads
204 FVERBOSE=off msetfeature "verbose"
205 # do not die here, mchecksum catches download errors
206 mdownload --uri "${uri}" --dir "${outputdir}"
207
208 # unset them to be sure
209 unset uri
210 unset subdir
211 unset outputdir
212 done
213
214 # recheck md5 sums after download
215 echo
216 echo -e "${COLBLUE}===${COLGREEN} Checking MD5 sums:${COLDEFAULT}"
217 mchecksum --rundir "${SOURCEDIR}/${PNAME}" --file "${db_md5_file}" --method md5 || die "md5 failed"
218 echo
219 else
220 echo -e "${COLBLUE}===${COLGREEN} All sources already fetched, nothing to do${COLDEFAULT}"
221 fi
222
223 # not needed anymore
224 unset SRC_URI
225 }
226
227 # dummy function, used if that does not exist in smage file
228 src_prepare()
229 {
230 echo "no src_prepare defined; doing nothing ..."
231 return 0
232 }
233
234 # dummy function, used if that does not exist in smage file
235 src_compile()
236 {
237 echo "no src_compile defined; doing nothing ..."
238 return 0
239 }
240
241 # dummy function, used if that does not exist in smage file
242 src_check()
243 {
244 echo "no src_check defined; doing nothing ..."
245 return 0
246 }
247
248 # dummy function, used if that does not exist in smage file
249 src_install()
250 {
251 echo "no src_install defined; doing nothing ..."
252 return 0
253 }
254
255 mlibdir()
256 {
257 local libdir=lib
258 [[ ${ARCH} = x86_64 ]] && libdir=lib64
259
260 echo "${libdir}"
261 }
262
263 mconfigure()
264 {
265 local myopts
266 if [[ ! -z ${CTARGET} ]]
267 then
268 myopts+=" --target=${CTARGET}"
269 fi
270
271 if [ -x ./configure ]
272 then
273 # if requested disable-static
274 if [[ ! -z $(./configure --help | grep -- '--.*able-static') ]]
275 then
276 if mqueryfeature '!static'
277 then
278 myopts+=" --disable-static"
279 else
280 myopts+=" --enable-static"
281 fi
282 fi
283
284 # always enable shared by default but not for waf configure
285 if [[ ! -z $(./configure --help | grep -- '--.*able-shared') ]] &&
286 [[ -z $(./configure --version | grep waf) ]]
287 then
288 myopts+=" --enable-shared"
289 fi
290
291 ./configure \
292 --prefix=/usr \
293 --host=${CHOST} \
294 --build=${CHOST} \
295 --mandir=/usr/share/man \
296 --infodir=/usr/share/info \
297 --datadir=/usr/share \
298 --sysconfdir=/etc \
299 --localstatedir=/var/lib \
300 --libdir=/usr/$(mlibdir) \
301 ${myopts} \
302 "$@" || die "mconfigure failed"
303 else
304 echo "configure is not an executable ..."
305 exit 1
306 fi
307 }
308
309 minstall()
310 {
311 if [ -f ./[mM]akefile -o -f ./GNUmakefile ]
312 then
313 make prefix=${BINDIR}/usr \
314 datadir=${BINDIR}/usr/share \
315 infodir=${BINDIR}/usr/share/info \
316 localstatedir=${BINDIR}/var/lib \
317 mandir=${BINDIR}/usr/share/man \
318 sysconfdir=${BINDIR}/etc \
319 libdir=${BINDIR}/usr/$(mlibdir) \
320 "$@" install || die "minstall failed"
321 else
322 die "no Makefile found"
323 fi
324 }
325
326 mmake()
327 {
328 make ${MAKEOPTS} ${EXTRA_EMAKE} "$@"
329 }
330
331 munpack()
332 {
333 local SRCFILE
334 local IFTAR
335 local DEST
336
337 SRCFILE=$1
338
339 if [[ -z $2 ]]
340 then
341 DEST=${BUILDDIR}
342 else
343 DEST=$2
344 fi
345
346 echo -e "${COLBLUE}>>>${COLGREEN} Unpacking ${SOURCEDIR}/${PNAME}/${SRCFILE}${COLDEFAULT}"
347
348 [[ ! -d ${DEST} ]] && install -d ${DEST}
349
350 case "${SRCFILE##*.}" in
351 bz2)
352 IFTAR="$(basename $SRCFILE .bz2)"
353 IFTAR="${IFTAR##*.}"
354 if [[ ${IFTAR} = tar ]]
355 then
356 tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tar.bz2 unpack failed."
357 else
358 pushd ${DEST} > /dev/null
359 bzcat ${SOURCEDIR}/${PNAME}/${SRCFILE} > ${DEST}/$(basename ${SRCFILE} .bz2) || die ".bz2 unpack failed."
360 popd > /dev/null
361 fi
362 ;;
363 gz)
364 IFTAR="$(basename $SRCFILE .gz)"
365 IFTAR="${IFTAR##*.}"
366 if [[ ${IFTAR} = tar ]]
367 then
368 tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tar.gz unpack failed."
369 else
370 pushd ${DEST} > /dev/null
371 zcat ${SOURCEDIR}/${PNAME}/${SRCFILE} > ${DEST}/$(basename ${SRCFILE} .gz) || die ".gz unpack failed."
372 popd > /dev/null
373 fi
374 ;;
375 xz)
376 IFTAR="$(basename $SRCFILE .xz)"
377 IFTAR="${IFTAR##*.}"
378 if [[ ${IFTAR} = tar ]]
379 then
380 tar --no-same-owner -xvJf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tar.xz unpack failed."
381 else
382 pushd ${DEST} > /dev/null
383 xzcat ${SOURCEDIR}/${PNAME}/${SRCFILE} > ${DEST}/$(basename ${SRCFILE} .xz) || die ".xz unpack failed."
384 popd > /dev/null
385 fi
386 ;;
387 tbz2|mpks|mpk)
388 tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tbz2 unpack failed."
389 ;;
390 tgz)
391 tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tgz unpack failed."
392 ;;
393 txz|mpkzs|mpkz)
394 tar --no-same-owner -xvJf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".txz unpack failed."
395 ;;
396 rar)
397 unrar x ${SOURCEDIR}/${PNAME}/${SRCFILE} ${DEST} || die ".rar unpack failed."
398 ;;
399 zip|xpi|jar)
400 unzip ${SOURCEDIR}/${PNAME}/${SRCFILE} -d ${DEST} || die ".zip unpack failed."
401 ;;
402 rpm)
403 pushd ${DEST} > /dev/null
404 rpm2targz ${SOURCEDIR}/${PNAME}/${SRCFILE} || die "rpm2targz: .rpm unpack failed."
405 tar --no-same-owner -xvzf ${SRCFILE/.rpm/.tar.gz} || die "tar: .rpm unpack failed."
406 if [[ -f ${DEST}/${SRCFILE/.rpm/.tar.gz} ]]
407 then
408 rm ${DEST}/${SRCFILE/.rpm/.tar.gz}
409 fi
410 ;;
411 *)
412 die "munpack failed"
413 ;;
414 esac
415 }
416
417 mpatch()
418 {
419 local PATCHOPTS
420 local PATCHFILE
421 local i
422
423 PATCHOPTS=$1
424 PATCHFILE=$2
425
426 if [[ -z $2 ]]
427 then
428 PATCHFILE=$1
429
430 ## patch level auto-detection, get patch level
431 for ((i=0; i < 10; i++))
432 do
433 patch --dry-run -Np${i} -i ${SOURCEDIR}/${PNAME}/${PATCHFILE} > /dev/null
434 if [[ $? = 0 ]]
435 then
436 PATCHOPTS="-Np${i}"
437 break
438 fi
439 done
440 fi
441
442 echo -e "${COLBLUE}*** ${COLGREEN}Applying patch '${PATCHFILE}'${COLDEFAULT}"
443 patch "${PATCHOPTS}" -i ${SOURCEDIR}/${PNAME}/${PATCHFILE}
444 }
445
446 mlibtoolize()
447 {
448 local opts="$@"
449 [[ -z ${opts} ]] && opts="--verbose --install --force"
450
451 libtoolize ${opts} || die "running: mlibtoolize ${opts}"
452 }
453
454 mautoreconf()
455 {
456 local opts="$@"
457 [[ -z ${opts} ]] && opts="--verbose --install --force"
458
459 autoreconf ${opts} || die "running: mautoreconf ${opts}"
460 }
461
462 minstalldocs()
463 {
464 local docfiles
465 local doc
466 docfiles="$@"
467
468 if [ ! -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} ]
469 then
470 install -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "creating doc dirs."
471 fi
472
473 for doc in ${docfiles}
474 do
475 if [ -f ${doc} ]
476 then
477 if mqueryfeature "compressdoc"
478 then
479 cat ${doc} | gzip -9c > ${BINDIR}/usr/share/doc/${PNAME}-${PVER}/$(basename ${doc}).gz || die "gzipping +installing ${doc}."
480 chmod 0644 ${BINDIR}/usr/share/doc/${PNAME}-${PVER}/$(basename ${doc}).gz || die "fixing permissions of ${doc}."
481 else
482 install -m 0644 ${doc} ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "installing ${doc}."
483 fi
484 fi
485 done
486 }
487
488 mstriplibs()
489 {
490 local stripdir="$@"
491
492 [[ -z ${stripdir} ]] && stripdir="${BINDIR}"
493 [[ -z ${STRIP_DYN_LIB} ]] && STRIP_DYN_LIB="--strip-debug"
494 find ${stripdir} ! -type d | xargs --no-run-if-empty file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs --no-run-if-empty strip ${STRIP_DYN_LIB} 2> /dev/null
495 }
496
497 mstripbins()
498 {
499 local stripdir="$@"
500
501 [[ -z ${stripdir} ]] && stripdir="${BINDIR}"
502 [[ -z ${STRIP_DYN_BIN} ]] && STRIP_DYN_BIN="--strip-debug"
503 find ${stripdir} ! -type d | xargs --no-run-if-empty file | grep "executable" | grep ELF | cut -f 1 -d : | xargs --no-run-if-empty strip ${STRIP_DYN_BIN} 2> /dev/null
504 }
505
506 mstripstatic()
507 {
508 local stripdir="$@"
509
510 [[ -z ${stripdir} ]] && stripdir="${BINDIR}"
511 [[ -z ${STRIP_STATIC_LIB} ]] && STRIP_STATIC_LIB="--strip-debug"
512 find ${stripdir} ! -type d | xargs --no-run-if-empty file | grep "ar archive" | cut -f 1 -d : | xargs --no-run-if-empty strip ${STRIP_STATIC_LIB} 2> /dev/null
513 }
514
515 mstriplibtoolarchive()
516 {
517 local stripdir="$@"
518
519 [[ -z ${stripdir} ]] && stripdir="${BINDIR}"
520 find ${stripdir} ! -type d -name \*.la | xargs --no-run-if-empty file | grep "libtool library" | cut -f 1 -d : | xargs --no-run-if-empty rm -f -- 2> /dev/null
521 }
522
523 mpurgetargets()
524 {
525 local stripdir="$@"
526 local target
527
528 [[ -z ${stripdir} ]] && stripdir=${BINDIR}
529 # nothing to do in this case
530 [[ -z ${PURGE_TARGETS[*]} ]] && return
531
532 for target in ${PURGE_TARGETS[*]}
533 do
534 # check if target is a regex pattern without any slashes
535 if [[ ${target} = ${target//\/} ]]
536 then
537 find ${BINDIR} -type f -name "${target}" | xargs --no-run-if-empty rm -f -- 2> /dev/null
538 else
539 rm -f -- ${target} 2> /dev/null
540 fi
541 done
542 }
543
544 mcompressdocs()
545 {
546 local bindir="$@"
547
548 if [ -d ${bindir}/usr/share/man ]
549 then
550 echo -e "${COLBLUE}===${COLGREEN} compressing man-pages ...${COLDEFAULT}"
551 ${MLIBDIR}/compressdoc -g -9 ${bindir}/usr/share/man
552 fi
553
554 if [ -d ${bindir}/usr/share/info ]
555 then
556 echo -e "${COLBLUE}===${COLGREEN} compressing info-pages ...${COLDEFAULT}"
557 ${MLIBDIR}/compressdoc -g -9 ${bindir}/usr/share/info
558 fi
559 }
560
561 sminclude()
562 {
563 local i
564
565 if [[ -n "$@" ]]
566 then
567 for i in $@
568 do
569 echo "--- Including ${SMAGESCRIPTSDIR}/include/${i}.sminc"
570 source ${SMAGESCRIPTSDIR}/include/${i}.sminc
571 done
572 echo
573 fi
574 }
575
576 march()
577 {
578 local retval
579
580 if [[ ! -z ${ARCH} ]]
581 then
582 echo "${ARCH}"
583 retval=0
584 else
585 retval=1
586 fi
587
588 return "${retval}"
589 }
590
591 marchsrcfile()
592 {
593 local retval
594 local var="$1"
595
596 [[ -z ${var} ]] && var="SRCFILE"
597
598 if [[ ! -z $(eval echo \$${var}_${ARCH/i*86/x86}) ]]
599 then
600 eval echo \$${var}_${ARCH/i*86/x86} | tr ';' '\n'
601 retval=0
602 else
603 retval=1
604 fi
605
606 return "${retval}"
607 }
608
609 marchsrcdir()
610 {
611 local retval
612 if [[ ! -z $(eval echo \$SRCDIR_${ARCH/i*86/x86}) ]]
613 then
614 eval echo \$SRCDIR_${ARCH/i*86/x86} | tr ';' '\n'
615 retval=0
616 else
617 retval=1
618 fi
619
620 return "${retval}"
621 }
622
623 marchdepend()
624 {
625 local retval
626
627 if [[ ! -z $(eval echo \$DEPEND_${ARCH/i*86/x86}) ]]
628 then
629 echo "\$(eval echo \\\$DEPEND_\${ARCH/i*86/x86} | tr ';' '\n')"
630 retval=0
631 else
632 retval=1
633 fi
634
635 return "${retval}"
636 }
637
638 marchsdepend()
639 {
640 local retval
641 if [[ ! -z $(eval echo \$SDEPEND_${ARCH/i*86/x86}) ]]
642 then
643 echo "\$(eval echo \\\$SDEPEND_\${ARCH/i*86/x86} | tr ';' '\n')"
644 retval=0
645 else
646 retval=1
647 fi
648
649 return "${retval}"
650 }
651
652 setup_distcc_environment()
653 {
654 if [ -x /usr/bin/distcc ]
655 then
656 echo -e "${COLBLUE}---${COLGREEN} Using DistCC for compilation ...${COLDEFAULT}"
657 export PATH=/usr/$(mlibdir)/distcc/bin:${PATH} || die "distcc: could not export new $PATH"
658
659 export DISTCC_DIR="${DISTCC_DIR}" || die "distcc_dir export failed"
660
661 # creating distcc tempdir
662 install -o distcc -g daemon -d ${DISTCC_DIR}
663 chmod 1777 ${DISTCC_DIR}
664 fi
665 }
666
667 setup_ccache_environment()
668 {
669 if [ -x /usr/bin/ccache ]
670 then
671 echo -e "${COLBLUE}---${COLGREEN} Using CCache for compilation ...${COLDEFAULT}"
672 export PATH=/usr/$(mlibdir)/ccache/bin:${PATH} || die "ccache: could not export new $PATH"
673 fi
674 }
675
676 # fixes given dependencies to match a MAGE_TARGET
677 # fix_mage_deps -target s/depend # <-- note -target !
678 fix_mage_deps()
679 {
680 local target="$1"
681 local depend="$2"
682 local NDEPEND
683 local sym dep cat pver pname
684
685 # first of all remove all tabs and duplicate lines
686 if [ -n "${depend}" ]
687 then
688 depend=$(echo "${depend}" | sed 's:\t::g' | sort -u)
689 fi
690
691 # deps and provides are special
692 # they must be fixed to match the target
693
694 # run this only if target and depend is not empty
695 if [ -n "${target}" ] && [ -n "${depend}" ]
696 then
697 # fix DEPEND
698 while read sym dep
699 do
700 # ignore empty lines
701 [[ -z ${dep} ]] && continue
702
703 cat="$(dirname ${dep})"
704 # change if not virtual
705 if [[ ${cat} = virtual ]]
706 then
707 pname="$(basename ${dep})"
708 else
709 # fix pver to target-pver
710 # to get pname-target-pver
711
712 # doing it backwards !
713 pver="${dep##*-}"
714 # full pver
715 pname="$(basename ${dep/-${pver}/})${target}-${pver}"
716 fi
717
718 # do not add empty lines
719 if [ -z "${NDEPEND}" ]
720 then
721 NDEPEND="${sym} ${cat}/${pname}"
722 else
723 NDEPEND="${NDEPEND}
724 ${sym} ${cat}/${pname}"
725 fi
726
727 unset cat pname pver
728 done << EOF
729 ${depend}
730 EOF
731 # set NDEPEND to DEPEND
732 depend="${NDEPEND}"
733 fi
734
735 echo "${depend}"
736 }
737
738 # build_mage_script(): helper functions for regen_mage_tree()
739 # generates an mage file with given information in smage file
740 # needs at least:
741 # PNAME name of pkg
742 # PVER version
743 # PBUILD revision
744 # PCAT category of the pkg
745 # PCATEGORIE category of the pkg (deprecated, use PCAT!)
746 # STATE state of pkg stable|unstable|old
747 # DESCRIPTION a short description (opt)
748 # HOMEPAGE homepage (opt)
749 # LICENSE license information of the pkg (opt)
750 # DEPEND runtime dependencies (opt)
751 # SDEPEND adds needed deps to build the pkg (opt)
752 # PROVIDE provides a virtual (opt)
753 #
754 # special tags:
755 # PKGTYPE type of pkg
756 # INHERITS which functions get included
757 # SPECIAL_FUNCTIONS special functions which should also be added
758 # warning: they get killed before the build starts !
759 # SPLIT_PACKAGES names of all subpackages which are splitted from parent
760 # SPLIT_PACKAGE_BASE base package name for splitpackages
761 # (only in the resulting magefile}
762 #
763 # MAGE_TREE_DEST target destination of the generated tree
764 # REGEN_MAGE_TREE set to 'true' to enable this
765 #
766 # gets called with build_mage_script target
767 build_mage_script()
768 {
769 local magefile
770 local dest
771 local target
772 local split_pkg_base
773 local sym
774 local depname
775
776 # if MAGE_TREE_DEST not set use BUILDDIR
777 : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}
778
779 # determinate which suffix this mage file should get, if any
780 [[ $1 = --target ]] && shift && target="-$1"
781
782 # mark package as splitpackage
783 [[ $1 = --split-pkg-base ]] && shift && split_pkg_base="$1"
784
785 # name of magefile
786 magefile="${PNAME}${target}-${PVER}-${PBUILD}.mage"
787
788 # destination to magefile
789 dest="${MAGE_TREE_DEST}/${PCAT}/${PNAME}${target}/${magefile}"
790
791 # show what we are doing
792 echo -e "${COLBLUE}===${COLGREEN} generating mage file:${COLDEFAULT}"
793 echo "${dest}"
794
795 install -d "$(dirname ${dest})"
796 # now build the mage file
797 > ${dest}
798
799 # pgkname and state
800 echo "PKGNAME=\"${PNAME}${target}-${PVER}-\${ARCH}$(print_distrotag)-${PBUILD}\"" >> ${dest}
801 echo "STATE=\"${STATE}\"" >> ${dest}
802
803 # description and homepage
804 echo "DESCRIPTION=\"${DESCRIPTION}\"" >> ${dest}
805 echo "HOMEPAGE=\"${HOMEPAGE}\"" >> ${dest}
806
807 # license information
808 echo "LICENSE=\"${LICENSE}\"" >> ${dest}
809
810 # special tags and vars
811 echo "PKGTYPE=\"${PKGTYPE}\"" >> ${dest}
812
813 # echo MAGE_TARGETS ## note -target is needed !
814 echo "MAGE_TARGETS=\"${target}\"" >> ${dest}
815
816 # split package base
817 echo "SPLIT_PACKAGE_BASE=\"${split_pkg_base}\"" >> ${dest}
818
819 # add special vars
820 if [ -n "${SPECIAL_VARS}" ]
821 then
822 local i
823 for i in ${SPECIAL_VARS}
824 do
825 # being tricky here :)
826 echo "${i}=\"$(eval echo \$${i})\"" >> ${dest}
827 done
828 fi
829
830 # add at least all includes
831 if [ -n "${INHERITS}" ]
832 then
833 echo -n "minclude" >> ${dest}
834 local i
835 for i in ${INHERITS}
836 do
837 echo -n " ${i}" >> ${dest}
838 done
839 # a CRLF is needed here!
840 echo >> ${dest}
841 fi
842
843 # deps and provides
844 echo "DEPEND=\"$(fix_mage_deps "${target}" "${DEPEND}")\"" >> ${dest}
845 echo "SDEPEND=\"$(fix_mage_deps "${target}" "${SDEPEND}")\"" >> ${dest}
846 echo "PROVIDE=\"${PROVIDE}\"" >> ${dest}
847
848 # add special functions
849 if [ -n "${SPECIAL_FUNCTIONS}" ]
850 then
851 local i
852 for i in ${SPECIAL_FUNCTIONS}
853 do
854 # add to mage (quotes needed !)
855 typeset -f "${i}" >> ${dest}
856 # unset to be safe (quotes needed !)
857 #unset "${i}" <-- later to get every target built
858 done
859 fi
860
861 # pre|post-install|removes
862 typeset -f preinstall >> ${dest}
863 typeset -f postinstall >> ${dest}
864 typeset -f preremove >> ${dest}
865 typeset -f postremove >> ${dest}
866 }
867
868 regen_mage_tree()
869 {
870 local subpackage
871
872 # build them only if requested
873 if mqueryfeature regentree
874 then
875 # run it without targets
876 if [[ -n ${MAGE_TARGETS} ]]
877 then
878 # build for each target a mage file
879 # run it with several targets
880 echo
881 for subpackage in ${MAGE_TARGETS}
882 do
883 build_mage_script --target "${subpackage}"
884 done
885 echo
886
887 # run it for splitpackages
888 elif [[ -n ${SPLIT_PACKAGES} ]]
889 then
890 local split_pkg_base="${PNAME}"
891 # save smage environment
892 split_save_variables
893 # build for each subpackage a mage file
894 # run it with several targets
895 echo
896 for subpackage in ${SPLIT_PACKAGES}
897 do
898 # get the right variables for the split
899 export PNAME="${subpackage}"
900 split_info_${subpackage}
901 # fix PCATEGORIE -> PCAT
902 if [[ ! -z ${PCATEGORIE} ]]
903 then
904 PCAT="${PCATEGORIE}"
905 unset PCATEGORIE
906 fi
907 # get the preinstall etc
908 split_export_inherits ${subpackage}
909 build_mage_script --split-pkg-base "${split_pkg_base}"
910 # delete split preinstall etc
911 split_delete_inherits ${subpackage}
912 # restore smage environment
913 split_restore_variables
914 done
915 echo
916 # unset all saved smage variables
917 split_unset_variables
918
919 else
920 echo
921 build_mage_script
922 echo
923 fi
924 fi
925
926 # now unset all uneeded vars to be safe
927 # unset PKGNAME <-- don't do that; smage needs this var
928 # unset to be safe (quotes needed !)
929 # for i in ${SPECIAL_FUNCTIONS}
930 # do
931 # unset "${i}"
932 # done
933 unset SPECIAL_FUNCTIONS
934 # for i in ${SPECIAL_VARS}
935 # do
936 # unset "${i}"
937 # done
938 unset SPECIAL_VARS
939 unset STATE
940 unset DESCRIPTION
941 unset HOMEPAGE
942 # unset PKGTYPE <-- don't do that either; smage needs this var
943 unset INHERITS
944 unset DEPEND
945 unset SDEPEND
946 unset PROVIDE
947 unset preinstall
948 unset postinstall
949 unset preremove
950 unset postremove
951 }
952
953 split_save_variables()
954 {
955 export SAVED_PNAME="${PNAME}"
956 export SAVED_PVER="${PVER}"
957 export SAVED_PBUILD="${PBUILD}"
958 export SAVED_PCAT="${PCAT}"
959 export SAVED_DESCRIPTION="${DESCRIPTION}"
960 export SAVED_HOMEPAGE="${HOMEPAGE}"
961 export SAVED_SPECIAL_VARS="${SPECIAL_VARS}"
962 export SAVED_STATE="${STATE}"
963 export SAVED_INHERITS="${INHERITS}"
964 export SAVED_DEPEND="${DEPEND}"
965 export SAVED_SDEPEND="${SDEPEND}"
966 export SAVED_PROVIDE="${PROVIDE}"
967 export SAVED_PKGTYPE="${PKGTYPE}"
968
969 # special handling needed for mage features
970 # pkgbuild
971 mqueryfeature "pkgbuild" && export SAVED_FEATURE_PKGBUILD="pkgbuild"
972 mqueryfeature "!pkgbuild" && export SAVED_FEATURE_PKGBUILD="!pkgbuild"
973 # strip
974 mqueryfeature "strip" && export SAVED_FEATURE_STRIP="strip"
975 mqueryfeature "!strip" && export SAVED_FEATURE_STRIP="!strip"
976 # libtool
977 mqueryfeature "libtool" && export SAVED_FEATURE_LIBTOOL="libtool"
978 mqueryfeature "!libtool" && export SAVED_FEATURE_LIBTOOL="!libtool"
979 # compressdoc
980 mqueryfeature "compressdoc" && export SAVED_FEATURE_COMPRESSDOC="compressdoc"
981 mqueryfeature "!compressdoc" && export SAVED_FEATURE_COMPRESSDOC="!compressdoc"
982
983 # bindir too
984 export SAVED_BINDIR="${BINDIR}"
985
986 # export the SPLIT_PACKAGE_BASE
987 export SPLIT_PACKAGE_BASE="${SAVED_PNAME}"
988
989 # functions
990 if [[ ! -z $(typeset -f preinstall) ]]
991 then
992 # rename the old one
993 local saved_preinstall
994 saved_preinstall=SAVED_$(typeset -f preinstall)
995 eval "${saved_preinstall}"
996 export -f SAVED_preinstall
997 fi
998
999 if [[ ! -z $(typeset -f postinstall) ]]
1000 then
1001 # rename the old one
1002 local saved_postinstall
1003 saved_postinstall=SAVED_$(typeset -f postinstall)
1004 eval "${saved_postinstall}"
1005 export -f SAVED_postinstall
1006 fi
1007
1008 if [[ ! -z $(typeset -f preremove) ]]
1009 then
1010 # rename the old one
1011 local saved_preremove
1012 saved_preremove=SAVED_$(typeset -f preremove)
1013 eval "${saved_preremove}"
1014 export -f SAVED_preremove
1015 fi
1016
1017 if [[ ! -z $(typeset -f postremove) ]]
1018 then
1019 # rename the old one
1020 local saved_postremove
1021 saved_postremove=SAVED_$(typeset -f postremove)
1022 eval "${saved_postremove}"
1023 export -f SAVED_postremove
1024 fi
1025 }
1026
1027 split_restore_variables()
1028 {
1029 export PNAME="${SAVED_PNAME}"
1030 export PVER="${SAVED_PVER}"
1031 export PBUILD="${SAVED_PBUILD}"
1032 export PCAT="${SAVED_PCAT}"
1033 export DESCRIPTION="${SAVED_DESCRIPTION}"
1034 export HOMEPAGE="${SAVED_HOMEPAGE}"
1035 export SPECIAL_VARS="${SAVED_SPECIAL_VARS}"
1036 export STATE="${SAVED_STATE}"
1037 export INHERITS="${SAVED_INHERITS}"
1038 export DEPEND="${SAVED_DEPEND}"
1039 export SDEPEND="${SAVED_SDEPEND}"
1040 export PROVIDE="${SAVED_PROVIDE}"
1041 export PKGTYPE="${SAVED_PKGTYPE}"
1042
1043 # special handling needed for mage features
1044 # pkgbuild
1045 FVERBOSE=off msetfeature "${SAVED_FEATURE_PKGBUILD}"
1046 # strip
1047 FVERBOSE=off msetfeature "${SAVED_FEATURE_STRIP}"
1048 # libtool
1049 FVERBOSE=off msetfeature "${SAVED_FEATURE_LIBTOOL}"
1050 # compressdoc
1051 FVERBOSE=off msetfeature "${SAVED_FEATURE_COMPRESSDOC}"
1052
1053 # bindir too
1054 export BINDIR="${SAVED_BINDIR}"
1055
1056 # functions
1057 if [[ ! -z $(typeset -f SAVED_preinstall) ]]
1058 then
1059 # rename the old one
1060 local saved_preinstall
1061 saved_preinstall=$(typeset -f SAVED_preinstall)
1062 eval "${saved_preinstall/SAVED_/}"
1063 export -f preinstall
1064 fi
1065
1066 if [[ ! -z $(typeset -f SAVED_postinstall) ]]
1067 then
1068 # rename the old one
1069 local saved_postinstall
1070 saved_postinstall=$(typeset -f SAVED_postinstall)
1071 eval "${saved_postinstall/SAVED_/}"
1072 export -f postinstall
1073 fi
1074
1075 if [[ ! -z $(typeset -f SAVED_preremove) ]]
1076 then
1077 # rename the old one
1078 local saved_preremove
1079 saved_preremove=$(typeset -f SAVED_preremove)
1080 eval "${saved_preremove/SAVED_/}"
1081 export -f preremove
1082 fi
1083
1084 if [[ ! -z $(typeset -f SAVED_postremove) ]]
1085 then
1086 # rename the old one
1087 local saved_postremove
1088 saved_postremove=$(typeset -f SAVED_postremove)
1089 eval "${saved_postremove/SAVED_/}"
1090 export -f postremove
1091 fi
1092 }
1093
1094 split_unset_variables()
1095 {
1096 # unset saved vars; not needed anymore
1097 unset SAVED_PNAME
1098 unset SAVED_PVER
1099 unset SAVED_PBUILD
1100 unset SAVED_PCAT
1101 unset SAVED_DESCRIPTION
1102 unset SAVED_HOMEPAGE
1103 unset SAVED_SPECIAL_VARS
1104 unset SAVED_STATE
1105 unset SAVED_PKGTYPE
1106 unset SAVED_INHERITS
1107 unset SAVED_DEPEND
1108 unset SAVED_SDEPEND
1109 unset SAVED_PROVIDE
1110 unset SAVED_BINDIR
1111 unset SAVED_PKGTYPE
1112 unset SAVED_FEATURE_PKGBUILD
1113 unset SAVED_FEATURE_STRIP
1114 unset SAVED_FEATURE_LIBTOOL
1115 unset SAVED_FEATURE_COMPRESSDOC
1116 unset SPLIT_PACKAGE_BASE
1117 unset -f SAVED_preinstall
1118 unset -f SAVED_postinstall
1119 unset -f SAVED_preremove
1120 unset -f SAVED_postremove
1121 }
1122
1123 split_export_inherits()
1124 {
1125 local subpackage="$1"
1126 local func
1127 local newfunc
1128
1129 for func in preinstall postinstall preremove postremove
1130 do
1131 if [[ ! -z $(typeset -f ${func}_${subpackage}) ]]
1132 then
1133 newfunc=$(typeset -f ${func}_${subpackage})
1134 newfunc="${newfunc/_${subpackage} (/ (}"
1135 eval "${newfunc}"
1136 fi
1137 done
1138 }
1139
1140 split_delete_inherits()
1141 {
1142 local subpackage="$1"
1143 local func
1144
1145 for func in preinstall postinstall preremove postremove
1146 do
1147 if [[ ! -z $(typeset -f ${func}_${subpackage}) ]]
1148 then
1149 unset -f ${func}
1150 fi
1151 done
1152 }
1153
1154 export_inherits()
1155 {
1156 local include="$1"
1157 shift
1158
1159 while [ "$1" ]
1160 do
1161 local functions="$1"
1162
1163 # sanity checks
1164 [ -z "${include}" ] && die "export_inherits(): \$include not given."
1165 [ -z "${functions}" ] && die "export_inherits(): \$functions not given."
1166
1167 eval "${functions}() { ${include}_${functions} ; }"
1168
1169 # debug
1170 [[ ${MAGEDEBUG} = on ]] && typeset -f "${functions}"
1171
1172 shift
1173 done
1174 }
1175
1176 generate_package_md5sum()
1177 {
1178 local dest
1179 local pcat
1180 local pname
1181 local pver
1182 local pbuild
1183 local parch
1184 local target
1185 local pkgname
1186
1187 # very basic getops
1188 for i in $*
1189 do
1190 case $1 in
1191 --pcat|-c) shift; pcat="$1" ;;
1192 --pname|-n) shift; pname="$1" ;;
1193 --pver|-v) shift; pver="$1" ;;
1194 --pbuild|-b) shift; pbuild="$1" ;;
1195 --parch|a) shift; parch="$1" ;;
1196 --target|t) shift; target="$1" ;;
1197 esac
1198 shift
1199 done
1200
1201 # sanity checks; abort if not given
1202 [ -z "${pcat}" ] && die "generate_package_md5sum() \$pcat not given."
1203 [ -z "${pname}" ] && die "generate_package_md5sum() \$pname not given."
1204 [ -z "${pver}" ] && die "generate_package_md5sum() \$pver not given."
1205 [ -z "${pbuild}" ] && die "generate_package_md5sum() \$pbuild not given."
1206 [ -z "${parch}" ] && die "generate_package_md5sum() \$parch not given."
1207
1208 # check needed global vars
1209 [ -z "${PKGDIR}" ] && die "generate_package_md5sum() \$PKGDIR not set."
1210 [ -z "${PKGSUFFIX}" ] && die "generate_package_md5sum() \$PKGSUFFIX not set."
1211
1212 # fix target as it may be empty !
1213 [ -n "${target}" ] && target="-${target}"
1214
1215 # build pkgname
1216 pkgname="${pname}${target}-${pver}-${parch}$(print_distrotag)-${pbuild}"
1217
1218 # build pkg-md5-sum only if requested
1219 if mqueryfeature regentree
1220 then
1221 echo -ne "${COLBLUE}===${COLGREEN} generating md5's for ${pkgname}.${PKGSUFFIX} ... ${COLDEFAULT}"
1222
1223 # abort if not exist
1224 if [ ! -f ${PKGDIR}/${pkgname}.${PKGSUFFIX} ]
1225 then
1226 echo -e "${COLRED}! exists${COLDEFAULT}"
1227 return 0
1228 fi
1229
1230 # if MAGE_TREE_DEST not set use BUILDDIR
1231 : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}
1232
1233 # setup md5 dir
1234 dest="${MAGE_TREE_DEST}/${pcat}/${pname}${target}/md5"
1235 install -d ${dest}
1236
1237 # gen md5sum
1238 ( cd ${PKGDIR}; md5sum "${pkgname}.${PKGSUFFIX}" ) \
1239 > ${dest}/${pkgname}.md5
1240 echo -e "${COLGREEN}done${COLDEFAULT}"
1241 fi
1242 }
1243
1244 source_pkg_build()
1245 {
1246 if [[ ${PKGTYPE} = virtual ]]
1247 then
1248 echo "Virtual package detected; src-pkg-tarball not necessary ..."
1249 return 0
1250 fi
1251
1252 if [[ ! -d ${SOURCEDIR}/${PNAME} ]]
1253 then
1254 echo "No SRC_URI defined; src-pkg-tarball not necessary ..."
1255 return 0
1256 fi
1257
1258 [ -z "${SRCPKGDIR}" ] && die "\$SRCPKGDIR not found. Please setup your ${MAGERC} correctly."
1259
1260 echo -e "${COLGREEN}Creating source package tarball ... ${COLDEFAULT}"
1261
1262 # include the smage2 file
1263 cp ${SMAGENAME} ${SOURCEDIR}/${PNAME}
1264
1265 ( cd ${SOURCEDIR}; tar cvjf ${BUILDDIR}/${PNAME}-${PVER}-${PBUILD}.tar.bz2 ${PNAME}; )
1266 [[ ! -d ${SRCPKGDIR} ]] && install -d ${SRCPKGDIR}
1267 mv ${BUILDDIR}/${PNAME}-${PVER}-${PBUILD}.tar.bz2 ${SRCPKGDIR}/${PNAME}-${PVER}-${PBUILD}.${SRCPKGSUFFIX}
1268
1269 echo -e "${COLGREEN}Source package ${COLBLUE}${PNAME}-${PVER}-${PBUILD}.${SRCPKGSUFFIX} ${COLGREEN}successfully builded.${COLDEFAULT}\n"
1270 }
1271
1272 step_by_step()
1273 {
1274 if mqueryfeature stepbystep
1275 then
1276 echo -e "${COLRED}Step-by-step enabled! Paused after $1.${COLDEFAULT}"
1277 echo "Press [enter] to continue"
1278 read
1279 fi
1280 }
1281
1282 resume_stamp()
1283 {
1284 local step="$1"
1285 [[ ! -d ${BUILDDIR}/.stamps ]] && install -d ${BUILDDIR}/.stamps
1286 touch ${BUILDDIR}/.stamps/smage-${PKGNAME}-${step}
1287 }
1288
1289 run_resume()
1290 {
1291 local step="$1"
1292
1293 if mqueryfeature "resume" && [[ -f ${BUILDDIR}/.stamps/smage-${PKGNAME}-${step} ]]
1294 then
1295 echo -e "${COLMAGENTA}${step} already processed; doing nothing${COLDEFAULT}"
1296 return 0
1297 else
1298 return 1
1299 fi
1300 }